From 1d1bc9ce433298fa57896d7da0faf35bb01af77e Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 14:05:52 +0000
Subject: [PATCH 28/51] check the references


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index d5c0342..3bda078 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -393,3 +393,36 @@ class ModuleMDLinter(object):
         vendor-defined key-value pairs."""
         if 'xmd' in self.mmd:
             self.check_is_dict(self.mmd['xmd'])
+
+    @error
+    @guidelines_link('#Module_references')
+    @detail("The 'references' block must be a dictionary (key/value).")
+    def lint_references_dict(self):
+        """Modules MAY define links referencing various upstream resources,
+        such as community website, project documentation or upstream bug
+        tracker."""
+        if 'references' in self.mmd:
+            self.check_is_dict(self.mmd['references'])
+
+    @warning
+    @guidelines_link('#Module_references')
+    @detail("The 'references' block must be a dictionary (key/value)."
+            " Recognized keys are 'community', 'documentation' and 'tracker'.")
+    def lint_references_keys(self):
+        """Modules MAY define links referencing various upstream resources,
+        such as community website, project documentation or upstream bug
+        tracker."""
+        if 'references' in self.mmd:
+            self.check(set(self.mmd['references']) <= {'community',
+                                                       'documentation',
+                                                       'tracker'})
+
+    @error
+    @guidelines_link('#Module_references')
+    @detail("The references must be scalar values (URLs).")
+    def lint_references_urls(self):
+        """Modules MAY define links referencing various upstream resources,
+        such as community website, project documentation or upstream bug
+        tracker."""
+        if 'references' in self.mmd:
+            self.check_is_scalar(*self.mmd['references'].values())

